#include <stdio.h>
#include <math.h>
#define maxpix 15000*15000 
#define DIR "/line6/cat/"
#define minpix 128*128         // use p*.fit minum pixels
// 20131010 add 130911_data's nbad_9?.fit 
float  a[maxpix];            
float  c[4032][4096];       

double a8[8],b8[8],s8[8],t8[8],aa[4],dd[4], xx[5],yy[5];
double rc,dc,hs2, pi,cx,cy;
double white, scale, flux,flux1,flux2,flux3,flux4;
int ty;
double ss=0.,fr=0.;

int    n1,n2,n3;              // n3 =0,1-4; if>0, use CCD_? only.
int    ccdno,idate;
int    ix[4],iy[4];
int    q1d[2][4],q2u[2][4],q3l[2][4],q4r[2][4];                     
int    id1=9999,id2=0;ip=0;

char   head[72][80],h[72][80],b[150],f1[50],f2[50],t[50];
char   ubad[4032][4096];     
char   c0[28],c1[14],c2[14];
FILE   *fp,*fp1,*fp2;

int pf[199][3],npf;

main(int ac, char **av)
{
  int    i,j,k,i1,i2,j1,j2,ij;
  int    p1,p2,q1,q2;
  double q0,x,y,alpha,delta,x1,y1;
  double updec,downdec;
  char   c9=34;              // "
  int    ix0,ix1,iy0,iy1;
  double z0,z1,z2,z3;
  double zx,zy,wx,wy;
  double x0,y0;
  double sky,adjpix;
  int ijk;

  if(ac<4){
    printf("\n\t ***** produce UBAND scaled fits ********");
    printf("\n\t            and  ANTI_cosmos_ray, only use mark<=3");
    printf("\n\t   ** data come from %s       jiang 201402",DIR);
    printf("\n\t   CALI:  use GATECORR (nfits6.pos9)\n");
    printf("\n\tUsage:  nqz6_4 file RA DEC [!]\n");
    printf("\n  Ex:     nqz6_4 a0479.fit 23:19:43.824 -05:05:22.20 [n]\n");
    printf("\n\t    RA DEC: (2000.0) center of pic; X,Y in pixel");
    printf("\n\t    Scale: FIXED!!, 0.454 arcsec/pixel");
    printf("\n\t    X Y    FIXED!!  is 8640 8200");
    printf("\n\t    fits file use /line5/jiang/ver_03/cat0?/a*.fit'head");
    printf("\n\t    n: 0 default, normal, 16_block adjust");
    printf("\n\t       1               no 16_block adjust");
    printf("\n\t       2               no 16_block adjust, save q*.fit");
    printf("\n\t       3 use /vega2/bok/qz6/a*.qz6 as qz_6.tmp\n\n"); 
    exit(0);
  }

  printf("\n\t   ** data come from %s            jiang 201402\n",DIR);
  fp=fopen("/vega2/rhbin/ubandlines.dat","r");
  if(!fp){ printf("ubandlines.dat not found!\n"); exit(0); }
  fgets(b,80,fp);
  for(i=0;i<4;i++){
    fgets(b,80,fp);
    sscanf(b,"%d %d %d %d",&q1d[0][i],&q2u[0][i],&q3l[0][i],&q4r[0][i]);}
  fgets(b,80,fp);
  for(i=0;i<4;i++){
    fgets(b,80,fp);
    sscanf(b,"%d %d %d %d",&q1d[1][i],&q2u[1][i],&q3l[1][i],&q4r[1][i]);}
  fclose(fp); 
 
  strcpy(f2,av[1]);
  scale=0.454;
  adjpix=(scale-0.454)/0.454;           // 20130310, for cnter shift

  strcpy(c1,av[2]);  chs(c1,&rc);       // center of RA
  strcpy(c2,av[3]);  chs(c2,&dc);       //        of Dec

  i=n3=j=0;  n1=8640;   n2=8200;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  toms2(rc,c1,1); toms2(dc,c2,0);
  printf("center: %s %s    %d*%d pixels%13.4lf%c scale\n",c1,c2,n1,n2,scale,c9);
  rc*=cx; dc*=cy; a8[6]=rc; a8[7]=dc;  
  hs2=(3600.*180./pi)/scale;                 
  b8[0]=-hs2; b8[1]=b8[2]=0; b8[3]=-b8[0]; b8[4]=(n1+1)/2.; b8[5]=(n2+1)/2.;
  xytoad(b8,a8);
  x=(n1+1)/2.; y=(n2+1)/2.;  xy_rad(rc,dc,x,y,&alpha,&delta,1,0);
  toms2(alpha,c1,1); toms2(delta,c2,0);
  rad_xy(rc,dc,alpha,delta,&x1,&y1,1,0);
  printf("%8.2lf %8.2lf-> %s %s-> %8.2lf %8.2lf\n",x,y,c1,c2,x1,y1);
  printf("4 corner's coodination:\n");
  x=n1;    y=n2;     xy_rad(rc,dc,x,y,&alpha,&delta,1,0);
  toms2(alpha,c1,1); toms2(delta,c2,0); 
  rad_xy(rc,dc,alpha,delta,&x1,&y1,1,0);
  printf("%8.2lf %8.2lf-> %s %s-> %8.2lf %8.2lf\n",x,y,c1,c2,x1,y1);

  x=1;     y=n2;     xy_rad(rc,dc,x,y,&alpha,&delta,1,0);
  toms2(alpha,c1,1); toms2(delta,c2,0);
  rad_xy(rc,dc,alpha,delta,&x1,&y1,1,0);
  printf("%8.2lf %8.2lf-> %s %s-> %8.2lf %8.2lf\n",x,y,c1,c2,x1,y1);
    updec=delta;

  x=n1;    y=1;      xy_rad(rc,dc,x,y,&alpha,&delta,1,0);
  toms2(alpha,c1,1); toms2(delta,c2,0); 
  rad_xy(rc,dc,alpha,delta,&x1,&y1,1,0);
  printf("%8.2lf %8.2lf-> %s %s-> %8.2lf %8.2lf\n",x,y,c1,c2,x1,y1);
    downdec=delta;
  x=1;     y=1;      xy_rad(rc,dc,x,y,&alpha,&delta,1,0);
  toms2(alpha,c1,1); toms2(delta,c2,0); 
  rad_xy(rc,dc,alpha,delta,&x1,&y1,1,0);
  printf("%8.2lf %8.2lf-> %s %s-> %8.2lf %8.2lf\n",x,y,c1,c2,x1,y1);

// read ver_03/cat0?/a*.fit, to see which fitname used
  for(i=0;i<strlen(f2);i++)if(f2[i]=='.')break; f2[i]=0;
  sscanf(&f2[1],"%d",&k);
             j=1;
  if(k>= 500)j=2;
  if(k>=1000)j=3;
  if(k>=1500)j=4;
  if(k>=2000)j=5;
  if(k>=2500)j=6;
  if(k>=3000)j=7;
  if(k>=9094)j=8;
  sprintf(b,"/line5/jiang/ver_03/cat0%d/%s.fit",j,f2);
  fp1=fopen(b,"rb"); if(!fp1){ printf("%s not found!\n",b); exit(0); }
  fread(h,72,80,fp1); fclose(fp1);
  sscanf(&h[0][45],"%d",&npf); j=1; k=32;
  for(i=0;i<npf;i++){
    sscanf(&h[j][k],"%4d_%4d_%d",&pf[i][0],&pf[i][1],&pf[i][2]);
    k+=12; if(k>=80){ j++; k=32; }
  }

  fp2=fopen("qz_6.tmp","w");
  fp1=fopen("nfits6.pos9","r");
  if(fp1==0)fp1=fopen("/vega2/rhbin/nfits6.pos9","r");
  if(fp1==0){ printf("nfits6.pos9 not found!\n"); exit(0); }
  puthead();
l10:
  fgets(b,150,fp1); if(feof(fp1))goto l20;
  if(b[0]=='#')goto l10;
  if(b[0]=='*')goto l20;              // if 1st char=='*', end_read
  for(ij=0;ij<80;ij++)if(b[ij]==32)break;
  flux=0.;
  sscanf(&b[ij],"%lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %d %lf %lf %lf %lf %d",
  &aa[1],&dd[1],&aa[0],&dd[0],&aa[2],&dd[2],&aa[3],&dd[3],&sky,&z0,&flux,
  &ty,&flux1,&flux2,&flux3,&flux4,&k); 
//  if(k>3)goto l10;
  sscanf(&b[8],"%4d_%4d_%d",&i,&j,&k);
  for(i1=0;i1<npf;i1++)if(i==pf[i1][0] && j==pf[i1][1] && k==pf[i1][2])goto l11;
  goto l10;
l11:
  if(flux==0.)goto l10;                         // if no usl_cali, ignore
  if(flux1==0.)flux1=flux;   flux1/=flux;
  if(flux2==0.)flux2=flux;   flux2/=flux;
  if(flux3==0.)flux3=flux;   flux3/=flux;
  if(flux4==0.)flux4=flux;   flux4/=flux;

  sscanf(&b[ij-11],"%d",&k); idate=0; if(k>5700)idate=1;
                                      if(k>6000)idate=2;
                                      if(k>6500)idate=3;
//20131010
  if(k==6546)idate=9;               // for 130911 data, 12 line blank

//if(dc>45.*cy || dc<-12.*cy)goto l10;          // assume data -12 ~~ 45 degree
  if(downdec>dd[2])goto l10;                    // 2012,2,8
  if(  updec<dd[0])goto l10;

  for(i=0;i<4;i++){
    rad_xy(rc,dc,aa[i],dd[i],&x1,&y1,1,0);      // as Schmidt tel.
    xx[i]=x1; yy[i]=y1;
  } xx[4]=xx[0]; yy[4]=yy[0];
  for(i=0;i<4;i++){ ix[i]=xx[i]+0.5; iy[i]=yy[i]+0.5; }
  if(ix[0]>100000 || ix[0]<-100000)goto l10; // 20120902
  i1=ix[0]; if(i1>ix[1])i1=ix[1];
  i2=ix[2]; if(i2<ix[3])i2=ix[3];
  j1=iy[0]; if(j1>iy[3])j1=iy[3];
  j2=iy[1]; if(j2<iy[2])j2=iy[2];
  if(j1<0)j1=0; if(j2>n2-1)j2=n2-1;
  if(i1<0)i1=0; if(i2>n1-1)i2=n1-1;
  if(j2-j1<10 || i2-i1<10)goto l10;   // <10 line overlap, not do
//     printf("%d %d    %d %d dj_di: %d %d\n",i1,j1,i2,j2,j2-j1,i2-i1);

  if(k<id1)id1=k; if(k>id2)id2=k;
  b[ij]=0; sprintf(t,"%s%s.fit",DIR,b);
  readpfit(t);                //  c[]_work, d[]_shrink_data
// printf("\tOn combinefile,    Col: %d ~~ %d   Row: %d ~~ %d\n",j1,j2,i1,i2);
// read nbad_?.fit in readpfit
  i=ccdno-1;  j=0; if(idate)j=1;
  p1=q3l[j][i]; p2=4095-q4r[j][i]; 
  q1=q1d[j][i]; q2=4031-q2u[j][i];
  printf("%2d: %s %s sky:%7.2lf  flux:%7.4lf",ip+1,&b[7],c0,white,flux); 
  fflush(stdout); ijk=0;
//printf("%d %d %d %d\n",p1,p2,q1,q2);
  for(j=0;j<n2*n1;j++)a[j]=0.;
  for(j=j1;j<=j2;j++)for(i=i1;i<=i2;i++){
    x0=i; y0=j;                          
    xy_rad(rc,dc,x0,y0,&alpha,&delta,1,0);           // big ix,iy
    rad_xy(s8[6],s8[7],alpha,delta,&x1,&y1,2,1);     // p*.fit x,y
    x=t8[0]*x1+t8[2]*y1+t8[4];
    y=t8[1]*x1+t8[3]*y1+t8[5];                       
    if(x<=p1 || x>=p2 )continue;         
    if(y<=q1 || y>=q2 )continue;          
    if(idate==0 && ccdno==4)if(x<=2048 || y>=2015)continue;   
    if(x< 2048 && y>=2016)flux=flux1;
    if(x< 2048 && y< 2016)flux=flux2;
    if(x>=2048 && y>=2016)flux=flux3;
    if(x>=2048 && y< 2016)flux=flux4;
    z1=z2=1.; x+=adjpix; y+=adjpix; 
    k=j*n1+i;
    ix0=x; ix1=ix0+1; wx=x-ix0;   zx=z1-wx;
    iy0=y; iy1=iy0+1; wy=y-iy0;   zy=z2-wy;
    if(ix1>=4096 || iy1>=4032)continue;
    ij=1;
    if(c[iy0][ix0]==0.)ij=0;
    if(c[iy0][ix1]==0.)ij=0;
    if(c[iy1][ix0]==0.)ij=0;
    if(c[iy1][ix1]==0.)ij=0;
    if(ij){ ijk++;
      z0=zx*zy; z1=wx*zy; z2=zx*wy; z3=wx*wy;
      a[k]=c[iy0][ix0]*z0+c[iy0][ix1]*z1+c[iy1][ix0]*z2+c[iy1][ix1]*z3;
      a[k]=(a[k]-sky)/flux+sky;                 // 20130210, 4 gate adjust.
    }
  } printf("%9d\n",ijk);
  if(ijk<minpix)goto l10;                      // 20130315
  sprintf(f1,"q%s.fit",&b[8]);
  for(j= 7;j<=10;j++)for(i=0;i<80;i++)head[j][i]=h[j][i];
  for(j=29;j<=33;j++)for(i=0;i<80;i++)head[j][i]=h[j][i];
  for(j=59;j<=65;j++)for(i=0;i<80;i++)head[j][i]=h[j][i];
  for(j=0;j<72;j++)for(i=0;i<80;i++)if(head[j][i]<32)head[j][i]=32;
  strcpy(b,"COMMENT= 'nqz6_4");
  for(i=1;i<ac;i++){ strcat(b," "); strcat(b,av[i]); }
  strcat(b," '");  k=strlen(b); 
  for(i=0;i<k;i++)head[28][i]=b[i];

  fp=fopen(f1,"wb"); fwrite(head,72,80,fp);
  swap4(a,n1*n2*4);  fwrite(a,n1*n2,4,fp);  fclose(fp);
  fprintf(fp2,"%s\n",f1);
  ip++; goto l10;
l20:
  fclose(fp1); fclose(fp2);
  if(ip==0){ printf("no data in this area !!\n"); exit(0); }
  k=0;
l21:
  if(ac<=4){
    sprintf(b,"a160 qz_6.tmp");             system(b); 
    sprintf(b,"qcomb6 qz_6.cal %s.fit",f2); system(b); 
  } else {
    sscanf(av[4],"%d",&k); 
    if(k==0){ ac=4; goto l21; }
    if(k==3){ sprintf(b,"cp /vega2/bok/qz6/%s.qz6 qz_6.tmp",f2); system(b); }
    sprintf(b,"qcomb6 qz_6.tmp %s.fit",f2); system(b); 
  }
  if(k!=2)system("rm q*.fit");
  else {
    sprintf(b,"a160 qz_6.tmp");             system(b);
    sprintf(b,"a16 %s.fit >>qz_6.all",f2);  system(b);
    sprintf(b,"mkdir %s",f2);               system(b);
    sprintf(b,"mv qz_6.* %s",f2);           system(b);
    sprintf(b,"mv q*.fit %s",f2);           system(b);
  }
}

readpfit(t)
char *t;
{
  int i,j,k,ii,jj,i1,j1;
  char f1[60];
  fp=fopen(t,"rb");
  if(fp==0){ printf("%s not found!\n",t); exit(0); }
  fread(h,72,80,fp);
  fread(c,4096*4032,4,fp); fclose(fp); swap4(c,4096*4032*4);
  k=indexpos(h,"CCD_NO: ",72);
  sscanf(&h[k][23],"%d",&ccdno);
  k=indexpos(h,"SKYADU  ",72);
  sscanf(&h[k][23],"%lf",&white);
  k=indexpos(h,"A81     ",72);
  for(i=0;i<8;i++)sscanf(&h[k+i][10],"%le",&s8[i]);
  xytoad(s8,t8);  
  for(i=0;i<27;i++)c0[i]=h[6][52+i]; c0[i]=0;
  sprintf(f1,"/vega2/rhbin/nbad_%d%d.fit",idate,ccdno);
//printf("%s\n",f1);
  fp=fopen(f1,"rb");
  if(!fp){ printf("%s not found!\n",f1); exit(0); }
  fseek(fp,36*80,0); fread(ubad,4032,4096,fp); fclose(fp);
  for(j=0;j<4032;j++)for(i=0;i<4096;i++)if(ubad[j][i] || c[j][i]<0.)c[j][i]=0.;
} 

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[20];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

#define bok  48.
rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
//                                 printf("%lf\n",tmp);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3lf",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2lf",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

puthead()
{
  int i,j,k;
  double x;
// pixel via scale adjust
// pixel_adjust === (scale-0.454)/scale
// 2013,3,10
//  y=(scale-0.454)/scale;
//  b8[4]+=y+10; b8[5]+=y+10;
//  xytoad(b8,a8);
//
  for(i=0;i<60;i++)head[i][31]='/';

  strcpy(&head[ 0][0], "SIMPLE  =                    T ");
  strcpy(&head[ 1][0], "BITPIX  =                  -32 ");
  strcpy(&head[ 2][0], "NAXIS   =                    2 ");
  sprintf(&head[3][0], "NAXIS1  =                %5d ",n1);
  sprintf(&head[4][0], "NAXIS2  =                %5d ",n2);
  toms2(rc/cx,c1,1); toms2(dc/cy,c2,0);
  sprintf(&head[11][0],"RA      =        %s ", c1);
  sprintf(&head[12][0],"DEC     =         %s ",c2);
  strcpy(&head[13][0], "HA      =                      ");
  strcpy(&head[14][0], "EPOCH   =               2000.0 ");
  strcpy(&head[15][0], "FILTER  =                    u ");
  sprintf(&head[16][0],"SCALE   =         %12.4lf ",scale);

  strcpy(&head[18][0], "INSTRUME=        BOK   90prime ");

  k=34;
  sprintf(&head[k++][0],"A81     = %20.12le ",a8[0]);
  sprintf(&head[k++][0],"A82     = %20.12le ",a8[1]);
  sprintf(&head[k++][0],"A83     = %20.12le ",a8[2]);
  sprintf(&head[k++][0],"A84     = %20.12le ",a8[3]);
  sprintf(&head[k++][0],"A85     = %20.12le ",a8[4]);
  sprintf(&head[k++][0],"A86     = %20.12le ",a8[5]);
  sprintf(&head[k++][0],"A87     = %20.12le ",a8[6]);
  sprintf(&head[k++][0],"A88     = %20.12le ",a8[7]);

  k=48;
  x=(a8[1]+a8[2])/(a8[0]-a8[3])/cy;                        // BOKs
  sprintf(&head[k++][0],"CTYPE1  = 'RA---ARC'           ");
  sprintf(&head[k++][0],"CTYPE2  = 'DEC--ARC'           ");
  sprintf(&head[k++][0],"CROTA2  = %20.12le ",x);
  sprintf(&head[k++][0],"CRVAL1  = %20.12le ",rc/cy);
  sprintf(&head[k++][0],"CRVAL2  = %20.12le ",dc/cy);
  sprintf(&head[k++][0],"CDELT1  = %20.12le ",a8[0]/cy);
  sprintf(&head[k++][0],"CDELT2  = %20.12le ",a8[3]/cy);
  sprintf(&head[k++][0],"CRPIX1  = %20.12le ",(n1+1)/2.);
  sprintf(&head[k++][0],"CRPIX2  = %20.12le ",(n2+1)/2.);

  for(i=0;i<70;i++)if(head[i][0]!=32)head[i][31]='/';
  strcpy(&head[71][0], "END"); 
}

